import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class FHT_IFHT extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public FHT_IFHT()
   {  setSize(600,600);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double [] invBits(double[]X, int Num)
   { double [] Y = new double[Num+1];
     for(int i = 0; i<= Num;i++)  Y[i] = X[i];
     // rbgt̕ёւ
     for(int j = 0; j< Num; j++)
     { int JP = j; int JX = 0; int K = 1;
       while( K < Num)
       {  int MD = JP % 2;  JX = JX * 2 + MD;
          JP /= 2; K *= 2;
       }
       if(j < JX){double temp = Y[j]; Y[j] = Y[JX]; Y[JX] = temp;}
     }
     return Y;
   }
   private void cmpFHT(double[] Y, int Num)
   { int n_half = Num / 2; int Ne = 1;
     while( Ne < Num)
     { int Sign=1; int n_half2 = n_half * 2;
       for(int JP = 0; JP < Num; JP += n_half2)
       {  int JX = 0;
          for(int j = JP ; j< JP + n_half; j++)
          { int jnh    = j + n_half ; double xtmp = ((double)Sign)* Y[jnh];
            Y[jnh] = Y[j] - xtmp; Y[j] = Y[j] + xtmp;
            JX += Ne;
          }
          Sign = - Sign;
        }
        n_half /= 2;  Ne *= 2;
     }
     Y[Num] = Y[0];
   }
   private double[] HT(double[] X, int Num)  //Hadamardϊ
   { double []Y = invBits(X, Num);
     cmpFHT(Y,Num);
     return Y;
   }
   private double[] IHT(double[] Y, int Num)  //Hadamardϊ
   { double []Z = invBits(Y, Num);
     cmpFHT(Z,Num);
     for(int i = 0; i <= Num; i++) Z[i] /= (double)Num;
     return Z;
   }
   
  private double[] Pulse(int Num)
  { double []X = new double[Num+1];
    int N1= 3 * Num / 8; int N2 = 6 * Num / 8;
    for(int k = 0; k < Num; k++)
    { X[k]=-1; if(k >= N1 && k < N2) X[k] = 1;
    }
    X[Num] = X[0];
    return X;
  }


   public int Xpos(double X)
   {  return (int)(X*50)+100;}
   public int Ypos(double Y)
   {  return 200- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { int KM=6;int Max =(int)(Math.pow(2,KM));// 2^KM+1 ̔zpӂ
     int i,k,j; boolean Flag = false;
     double [] X  = Pulse(Max);
     double [] Y1 = HT (X, Max);
     double [] Y2 = IHT(Y1,Max);

     setTitle("A_}[ϊ");
     g.drawString("HT",210,200);
     g.drawString("IHT",210,300);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, X[k]/2, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02+3.5, Y1[k]/20, Flag);
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, Y2[k]/2-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new FHT_IFHT();
      w.setVisible(true);
   }
}
